function deof_analysis_plot(eof, eof0, deof, ev, pev0, dev, dev0, dlon,dlat,lon0,lat0)
xdim=length(eof(1,:,1));  ydim=length(eof(1,1,:));

% -----------------------
% plot
% -----------------------
clf; fsize=10; fsize2=0.6*fsize;
xlon=dlon*(1:xdim)+lon0; ylat=dlat*(1:ydim)+lat0;

my_colormap

%  eofs
% switch sign of eof0 if correlated with similar eof 
for n=1:4; cor=0.0;
    for m=1:4
        cc=pattern_correlation(eof0(n,:,:), eof(m,:,:));
        if abs(cc) > cor
           cor=abs(cc); if cc < 0.0; eof0(n,:,:)=-eof0(n,:,:); end
        end
    end
end
e=eof; d=deof; e0=eof0; 
clev=max(max(abs(eof(1,:,:))))*(-1.05:0.1:1.05);

e(eof(:,:,:)<clev(1))      =clev(1);            % replace values <min-contour
e(abs(eof(:,:,:))<1e-10)   =-1.5*abs(clev(1));  % replace undefs
e0(eof0(:,:,:)<clev(1))    =clev(1);           % replace values <min-contour
e0(abs(eof0(:,:,:))<1e-10) =-1.5*abs(clev(1)); % replace undefs
for n=1:4
  subplot(4,3,3*n-2)
  contourf(xlon,ylat,squeeze(e(n,:,:))',clev)
  caxis([clev(1) clev(21)]); grid on; title(['EOF-',num2str(n)])
  subplot(4,3,3*n-1)
  contourf(xlon,ylat,squeeze(e0(n,:,:))',clev)
  caxis([clev(1) clev(21)]); grid on; title(['EOF0-',num2str(n)])
end

%   eigenvalues
subplot(3,3,3)
plot(ev,'black','linewidth',2.0);hold on
plot(pev0,'r','linewidth',2.0)
evmx=max([ev,pev0]);
axis([0 10 0 1.5*evmx]); set(gca,'xtick',(1:10),'fontsize',fsize)
title('eigenvalues')
xlabel('eigenvalue','fontsize',fsize2);
ylabel('explained variance','fontsize',fsize2);
set(gca,'fontsize',fsize2)
legend('EOF eigenvalues ','Null hypothesis projeted',1)

%  deofs
% switch sign of deof if correlated with similar eof
for n=1:2; cor=0.0;
    for m=1:4
        cc=pattern_correlation(deof(n,:,:), eof(m,:,:));
        if abs(cc) > cor
           cor=abs(cc); if cc < 0.0; d(n,:,:)=-deof(n,:,:); end
        end
    end
end
d(abs(deof(:,:,:))<1e-10)=-1.5*abs(clev(1)); % replace undefs & values <min-contour
for n=1:2
  subplot(4,3,3*n+6)
  ttext=['DEOF-',num2str(n),'(',num2str(round(dev(n))),'/',num2str(round(dev0(n))),')'];
  contourf(xlon,ylat,squeeze(d(n,:,:))',clev); caxis([clev(1) clev(21)]); grid on;
  title(ttext)
end
colorbar

return
