%
%  shell for the deof analysis
%  it shall read and cuto ut the data and compute the eofs/deof/ and plot them
%
clear

%--------------------------------------
% input
%--------------------------------------
% use data from dommenget 2007 ENSO example
% original eof-analysis eof.hadisst.3x3.trop.pac_deof.ctl
%
%* X is varying   Lon = 102 to 291   X = 95 to 158
%* Y is varying   Lat = -31.5 to 31.5   Y = 20 to 41
%*  T-dim: T = 1 to 1608
%
dir='./';
dfile='HADISST_1870-2003.3x3.ano.gad';
xdim0=120; ydim0=60; tdim0=1608;   % field dimensions of input data
xdim=64;   ydim=22;  tdim=tdim0; % field dimensions of analyzed data
x1=95 ; x2=158; y1=20; y2=41;
dlon=3.0; dlat=dlon; 
lat0=-31.5; lon0=0.0;
ndgf=tdim0;


%---------------------------------------
% read data
data0=zeros(tdim0,xdim0,ydim0);
fid = fopen([dir,dfile],'r');
xin=zeros(xdim0,ydim0);
for t=1:tdim
    xin=fread(fid,[xdim0,ydim0],'float');
    xin(xin>9.9e3)=0.0; % replace undefs
    data0(t,:,:)=xin;
end

% plot data matrix 2 time steps
figure(1); clf
subplot(2,2,1)
clev=-1.05:0.1:1.05; clev=2.*clev;
contourf(squeeze(data0(1,:,:))',clev);
caxis([clev(1) clev(length(clev))]); grid on
title('input data t=1')
subplot(2,2,2)
contourf(squeeze(data0(1200,:,:))',clev);
caxis([clev(1) clev(length(clev))]); grid on; colorbar
title('input data t=1200')

%---------------------------------------
% cat out region for eof-analysis
data = zeros(tdim,xdim,ydim);
% x1=95 ; x2=158; y1=20; y2=41;
data(:,1:(xdim0-x1)+1,:) = data0(:,x1:xdim0,y1:y2);
data(:,(xdim0-x1)+2:xdim,:) = data0(:,1:x2-xdim0,y1:y2);

% plotcut out data matrix 2 time steps
subplot(2,2,3)
contourf(squeeze(data(1,:,:))',clev);
caxis([clev(1) clev(length(clev))]); grid on
title('cut out data t=1')
subplot(2,2,4)
contourf(squeeze(data(1200,:,:))',clev);
caxis([clev(1) clev(length(clev))]); grid on
title('cut out data t=1200')

%--------------------------------------
% deof analysis
[eof, eof0, deof, ev, pev0, dev, dev0] = deof_analysis(data,dlon,dlat,lat0,ndgf);

%--------------------------------------
% plot deof-analysis results
figure(2)
deof_analysis_plot(eof, eof0, deof, ev, pev0, dev, dev0, dlon,dlat,lon0,lat0)

